import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;
/**
 * GUI implementeaza vizualizarea si controlorul pentru
 * problema 'a' din fisierul Colocviu_POO_a_b.doc
 * @author Marius.Joldos@cs.utcluj.ro
 * @version 2012.01.06
 */
public class GUI extends JFrame
{
    // instance variables - replace the example below with your own
    private JPanel panouLitere;
    private JPanel panouControl;
    private JPanel p = new JPanel();
    private JButton[][] patrate = new JButton[7][7];
    private JButton pas = new JButton("Pas");
    private JTextField numeFisier = new JTextField(20);
    private boolean fisierIncarcat = false;
    String vocale;
    String consoane;
    Romb r;
    /**
     * Constructor for objects of class GUI
     */
    public GUI()
    {
        super("Romb");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setPreferredSize(new Dimension(400, 440));
        setContentPane(p);
        p.setLayout(new BorderLayout());
        panouLitere = new JPanel();
        panouControl = new JPanel();
        panouLitere.setLayout(new GridLayout(7, 7));
        panouLitere.setBackground(Color.WHITE);
        for (int i = 0; i < patrate.length; i++)
            for (int j=0; j < patrate[i].length; j++)
            {
                patrate[i][j]=new JButton(" ");
                panouLitere.add(patrate[i][j]);
        }
        panouControl.setLayout(new BoxLayout(panouControl, BoxLayout.X_AXIS));
        numeFisier.setText("Litere.txt");
        panouControl.add(numeFisier);
        panouControl.add(pas);
        class ClickListener implements ActionListener 
        {
            public void actionPerformed(ActionEvent e)
            {
                if (fisierIncarcat)
                    executaPas();
                else
                {
                    try
                    {
                        FileReader f = new FileReader(numeFisier.getText());
                        BufferedReader b = new BufferedReader(f);
                        vocale   = b.readLine();
                        consoane = b.readLine();
                        r = new Romb(vocale, consoane);
                        System.out.println("Vocale:" + vocale + "\nConsoane:" + consoane);
                        puneLitere();
                        fisierIncarcat = true;
                    }
                    catch (FileNotFoundException e1)
                    {
                        JOptionPane.showMessageDialog(null, "'" + numeFisier.getText() + "'" +
                            " nu exista", "Eroare",  JOptionPane.ERROR_MESSAGE);
                    }
                    catch (IOException e2)
                    {
                        JOptionPane.showMessageDialog(null, e2.getMessage(), "Eroare",  JOptionPane.ERROR_MESSAGE);
                    }
                }
            }
        }
        pas.addActionListener(new ClickListener());
        p.add(panouControl, BorderLayout.SOUTH);
        p.add(panouLitere, BorderLayout.CENTER);
    }

    public void puneLitere()
    {
        for (int i = 0; i < patrate.length; i++)
            for (int j=0; j < patrate[i].length; j++)
            {
                patrate[i][j].setText(r.getText(i, j));
                if (r.eVocala(i, j))
                    patrate[i][j].setBackground(Color.YELLOW);
                else
                if (r.eConsoana(i, j))
                    patrate[i][j].setBackground(Color.RED);
                else
                    patrate[i][j].setBackground(Color.WHITE);
        }
        repaint();
    }

    public void executaPas()
    {
        System.out.println("GUI.executaPas");
        r.executaPas();
        puneLitere();
    }

    public static void main()
    {
        GUI g=new GUI();
        g.pack();
        g.setVisible(true);
    }
}
