import java.util.Random;
/**
 * Implementeaza modelul pentru problema 'a' din fisierul Colocviu_POO_a_b.doc
 * @author Marius.Joldos@cs.utcluj.ro
 * @version 2012.01.06
 */
public class Romb
{
    private Random rand = new Random();
    private boolean vocalaInCentru = true;
    private int[][] sablon = new int[][]
        {
            //0 1 2 3 4 5 6
            {0,0,0,4,0,0,0}, // 0
            {0,0,4,3,4,0,0}, // 1
            {0,4,3,2,3,4,0}, // 2
            {4,3,2,1,2,3,4}, // 3
            {0,4,3,2,3,4,0}, // 4
            {0,0,4,3,4,0,0}, // 5
            {0,0,0,4,0,0,0}, // 6
        };
    StringBuffer litere=new StringBuffer("");
    private char[][] patrate = new char[7][7];
    String[] toateLiterele = new String[2];

    /**
     * Constructor for objects of class Romb
     */
    public Romb(String vocale, String consoane)
    {
        // initialise instance variables
        toateLiterele[0] = vocale;
        toateLiterele[1] = consoane;
        for (int i=0; i <= patrate.length/2; i++)
            litere.append(toateLiterele[i % 2].charAt(rand.nextInt(toateLiterele[i % 2].length())));
        System.out.println("Litere: " + litere);
        setLitere();
    }

    public boolean eVocala(int rind, int coloana)
    {
        return toateLiterele[0].indexOf(patrate[rind][coloana]) >= 0;
    }
    public boolean eConsoana(int rind, int coloana)
    {
        return toateLiterele[1].indexOf(patrate[rind][coloana]) >= 0;
    }
    private void setLitere()
    {
        for (int i = 0; i < patrate.length; i++)
            for (int j=0; j < patrate[i].length; j++)
            {
                if (sablon[i][j] > 0)
                    patrate[i][j] = litere.charAt(sablon[i][j]-1);
                else
                    patrate[i][j] = ' ';
            }
    }


    public void executaPas()
    {
        System.out.println("Romb.executaPas");
        vocalaInCentru = !vocalaInCentru;
        litere.deleteCharAt(litere.length()-1);
        int index = (vocalaInCentru)? 0: 1;
        litere.insert(0, toateLiterele[index].charAt(rand.nextInt(toateLiterele[index].length())));
        System.out.println("Litere: " + litere);
        setLitere();
    }
    public String getText(int rind, int coloana)
    {
        StringBuffer s= new StringBuffer("_");
        s.setCharAt(0, patrate[rind][coloana]);
        return new String(s);
    }
}
